diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/test/packet-metadata-test.cc ns-3.36/src/network/test/packet-metadata-test.cc
--- ns-3.35/src/network/test/packet-metadata-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/test/packet-metadata-test.cc	2022-04-30 18:23:58.110734700 -0700
@@ -61,7 +61,7 @@
   bool m_ok; //!< True if no error is signalled.
 };
 
-TypeId 
+TypeId
 HistoryHeaderBase::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::HistoryHeaderBase")
@@ -124,7 +124,7 @@
 {
   std::ostringstream oss;
   oss << "ns3::HistoryHeader<"<<N<<">";
-  static TypeId tid = TypeId (oss.str ().c_str ())
+  static TypeId tid = TypeId (oss.str ())
     .SetParent<HistoryHeaderBase> ()
     .AddConstructor<HistoryHeader<N> > ()
   ;
@@ -132,25 +132,25 @@
 }
 
 template <int N>
-TypeId 
+TypeId
 HistoryHeader<N>::GetInstanceTypeId (void) const
 {
   return GetTypeId ();
 }
 template <int N>
-void 
+void
 HistoryHeader<N>::Print (std::ostream &os) const
 {
   NS_ASSERT (false);
 }
 template <int N>
-uint32_t 
+uint32_t
 HistoryHeader<N>::GetSerializedSize (void) const
 {
   return N;
 }
 template <int N>
-void 
+void
 HistoryHeader<N>::Serialize (Buffer::Iterator start) const
 {
   start.WriteU8 (N, N);
@@ -200,7 +200,7 @@
   bool m_ok; //!< True if no error is signalled.
 };
 
-TypeId 
+TypeId
 HistoryTrailerBase::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::HistoryTrailerBase")
@@ -261,7 +261,7 @@
 {
   std::ostringstream oss;
   oss << "ns3::HistoryTrailer<"<<N<<">";
-  static TypeId tid = TypeId (oss.str ().c_str ())
+  static TypeId tid = TypeId (oss.str ())
     .SetParent<HistoryTrailerBase> ()
     .AddConstructor<HistoryTrailer<N> > ()
   ;
@@ -269,25 +269,25 @@
 }
 
 template <int N>
-TypeId 
+TypeId
 HistoryTrailer<N>::GetInstanceTypeId (void) const
 {
   return GetTypeId ();
 }
 template <int N>
-void 
+void
 HistoryTrailer<N>::Print (std::ostream &os) const
 {
   NS_ASSERT (false);
 }
 template <int N>
-uint32_t 
+uint32_t
 HistoryTrailer<N>::GetSerializedSize (void) const
 {
   return N;
 }
 template <int N>
-void 
+void
 HistoryTrailer<N>::Serialize (Buffer::Iterator start) const
 {
   start.Prev (N);
@@ -323,12 +323,10 @@
   /**
    * Checks the packet header and trailer history
    * \param p The packet
-   * \param file The file name
-   * \param line The line number
    * \param n The number of variable arguments
    * \param ... The variable arguments
    */
-  void CheckHistory (Ptr<Packet> p, const char *file, int line, uint32_t n, ...);
+  void CheckHistory (Ptr<Packet> p, uint32_t n, ...);
   virtual void DoRun (void);
 private:
   /**
@@ -349,7 +347,7 @@
 }
 
 void
-PacketMetadataTest::CheckHistory (Ptr<Packet> p, const char *file, int line, uint32_t n, ...)
+PacketMetadataTest::CheckHistory (Ptr<Packet> p, uint32_t n, ...)
 {
   std::list<int> expected;
   va_list ap;
@@ -420,7 +418,7 @@
 error:
   std::ostringstream failure;
   failure << "PacketMetadata error. Got:\"";
-  for (std::list<int>::iterator i = got.begin (); 
+  for (std::list<int>::iterator i = got.begin ();
        i != got.end (); i++)
     {
       failure << *i << ", ";
@@ -432,7 +430,7 @@
       failure << *j << ", ";
     }
   failure << "\"";
-  NS_TEST_ASSERT_MSG_EQ_INTERNAL (false, true, failure.str (), file, line);
+  NS_TEST_ASSERT_MSG_EQ (false, true, failure.str ());
 }
 
 #define ADD_HEADER(p, n)                                           \
@@ -457,13 +455,13 @@
   }
 #define CHECK_HISTORY(p, ...)                                      \
   {                                                                \
-    CheckHistory (p, __FILE__, __LINE__, __VA_ARGS__);             \
+    CheckHistory (p, __VA_ARGS__);                                 \
     uint32_t size = p->GetSerializedSize ();                       \
     uint8_t* buffer = new uint8_t[size];                           \
     p->Serialize (buffer, size);                                   \
     Ptr<Packet> otherPacket = Create<Packet> (buffer, size, true); \
     delete [] buffer;                                              \
-    CheckHistory (otherPacket, __FILE__, __LINE__, __VA_ARGS__);   \
+    CheckHistory (otherPacket, __VA_ARGS__);                       \
   }
 
 
@@ -491,13 +489,13 @@
   ADD_HEADER (p, 1);
   ADD_HEADER (p, 2);
   ADD_HEADER (p, 3);
-  CHECK_HISTORY (p, 4, 
+  CHECK_HISTORY (p, 4,
                  3, 2, 1, 10);
   ADD_HEADER (p, 5);
-  CHECK_HISTORY (p, 5, 
+  CHECK_HISTORY (p, 5,
                  5, 3, 2, 1, 10);
   ADD_HEADER (p, 6);
-  CHECK_HISTORY (p, 6, 
+  CHECK_HISTORY (p, 6,
                  6, 5, 3, 2, 1, 10);
 
   p = Create<Packet> (10);
@@ -505,7 +503,7 @@
   ADD_HEADER (p, 2);
   ADD_HEADER (p, 3);
   REM_HEADER (p, 3);
-  CHECK_HISTORY (p, 3, 
+  CHECK_HISTORY (p, 3,
                  2, 1, 10);
 
   p = Create<Packet> (10);
@@ -514,7 +512,7 @@
   ADD_HEADER (p, 3);
   REM_HEADER (p, 3);
   REM_HEADER (p, 2);
-  CHECK_HISTORY (p, 2, 
+  CHECK_HISTORY (p, 2,
                  1, 10);
 
   p = Create<Packet> (10);
@@ -535,46 +533,46 @@
   REM_HEADER (p1, 2);
   REM_HEADER (p1, 1);
   CHECK_HISTORY (p1, 1, 10);
-  CHECK_HISTORY (p, 4, 
+  CHECK_HISTORY (p, 4,
                  3, 2, 1, 10);
   ADD_HEADER (p1, 1);
   ADD_HEADER (p1, 2);
-  CHECK_HISTORY (p1, 3, 
+  CHECK_HISTORY (p1, 3,
                  2, 1, 10);
-  CHECK_HISTORY (p, 4, 
+  CHECK_HISTORY (p, 4,
                  3, 2, 1, 10);
   ADD_HEADER (p, 3);
-  CHECK_HISTORY (p, 5, 
+  CHECK_HISTORY (p, 5,
                  3, 3, 2, 1, 10);
   ADD_TRAILER (p, 4);
-  CHECK_HISTORY (p, 6, 
+  CHECK_HISTORY (p, 6,
                  3, 3, 2, 1, 10, 4);
   ADD_TRAILER (p, 5);
-  CHECK_HISTORY (p, 7, 
+  CHECK_HISTORY (p, 7,
                  3, 3, 2, 1, 10, 4, 5);
   REM_HEADER (p, 3);
-  CHECK_HISTORY (p, 6, 
+  CHECK_HISTORY (p, 6,
                  3, 2, 1, 10, 4, 5);
   REM_TRAILER (p, 5);
-  CHECK_HISTORY (p, 5, 
+  CHECK_HISTORY (p, 5,
                  3, 2, 1, 10, 4);
   p1 = p->Copy ();
   REM_TRAILER (p, 4);
-  CHECK_HISTORY (p, 4, 
+  CHECK_HISTORY (p, 4,
                  3, 2, 1, 10);
-  CHECK_HISTORY (p1, 5, 
+  CHECK_HISTORY (p1, 5,
                  3, 2, 1, 10, 4);
   p1->RemoveAtStart (3);
-  CHECK_HISTORY (p1, 4, 
+  CHECK_HISTORY (p1, 4,
                  2, 1, 10, 4);
   p1->RemoveAtStart (1);
-  CHECK_HISTORY (p1, 4, 
+  CHECK_HISTORY (p1, 4,
                  1, 1, 10, 4);
   p1->RemoveAtStart (1);
-  CHECK_HISTORY (p1, 3, 
+  CHECK_HISTORY (p1, 3,
                  1, 10, 4);
   p1->RemoveAtEnd (4);
-  CHECK_HISTORY (p1, 2, 
+  CHECK_HISTORY (p1, 2,
                  1, 10);
   p1->RemoveAtStart (1);
   CHECK_HISTORY (p1, 1, 10);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/test/packet-test-suite.cc ns-3.36/src/network/test/packet-test-suite.cc
--- ns-3.35/src/network/test/packet-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/test/packet-test-suite.cc	2022-04-30 18:23:58.110734700 -0700
@@ -20,7 +20,6 @@
 #include "ns3/packet.h"
 #include "ns3/packet-tag-list.h"
 #include "ns3/test.h"
-#include "ns3/unused.h"
 #include <limits>     // std:numeric_limits
 #include <string>
 #include <cstdarg>
@@ -93,7 +92,7 @@
   static TypeId GetTypeId (void) {
     std::ostringstream oss;
     oss << "anon::ATestTag<" << N << ">";
-    static TypeId tid = TypeId (oss.str ().c_str ())
+    static TypeId tid = TypeId (oss.str ())
       .SetParent<ATestTagBase> ()
       .SetGroupName ("Network")
       .HideFromDocumentation ()
@@ -251,7 +250,7 @@
   static TypeId GetTypeId (void) {
     std::ostringstream oss;
     oss << "anon::ATestHeader<" << N << ">";
-    static TypeId tid = TypeId (oss.str ().c_str ())
+    static TypeId tid = TypeId (oss.str ())
       .SetParent<ATestHeaderBase> ()
       .SetGroupName ("Network")
       .HideFromDocumentation ()
@@ -337,7 +336,7 @@
   static TypeId GetTypeId (void) {
     std::ostringstream oss;
     oss << "anon::ATestTrailer<" << N << ">";
-    static TypeId tid = TypeId (oss.str ().c_str ())
+    static TypeId tid = TypeId (oss.str ())
       .SetParent<ATestTrailerBase> ()
       .SetGroupName ("Network")
       .HideFromDocumentation ()
@@ -422,11 +421,11 @@
 
 // Check byte tags on a packet, checks name, start, end
 #define CHECK(p, n, ...)                                \
-  DoCheck (p, __FILE__, __LINE__, n, __VA_ARGS__)
+  DoCheck (p, n, __VA_ARGS__)
 
 // Check byte tags on a packet, checks name, start, end, data
 #define CHECK_DATA(p, n, ...)                           \
-  DoCheckData (p, __FILE__, __LINE__, n, __VA_ARGS__)
+  DoCheckData (p, n, __VA_ARGS__)
 
 /**
  * \ingroup network-test
@@ -443,21 +442,17 @@
   /**
    * Checks the packet
    * \param p The packet
-   * \param file The file name
-   * \param line The line number
    * \param n The number of variable arguments
    * \param ... The variable arguments
    */
-  void DoCheck (Ptr<const Packet> p, const char *file, int line, uint32_t n, ...);
+  void DoCheck (Ptr<const Packet> p, uint32_t n, ...);
   /**
    * Checks the packet and its data
    * \param p The packet
-   * \param file The file name
-   * \param line The line number
    * \param n The number of variable arguments
    * \param ... The variable arguments
    */
-  void DoCheckData (Ptr<const Packet> p, const char *file, int line, uint32_t n, ...);
+  void DoCheckData (Ptr<const Packet> p, uint32_t n, ...);
 };
 
 
@@ -466,7 +461,7 @@
 }
 
 void
-PacketTest::DoCheck (Ptr<const Packet> p, const char *file, int line, uint32_t n, ...)
+PacketTest::DoCheck (Ptr<const Packet> p, uint32_t n, ...)
 {
   std::vector<struct Expected> expected;
   va_list ap;
@@ -488,9 +483,9 @@
       struct Expected e = expected[j];
       std::ostringstream oss;
       oss << "anon::ATestTag<" << e.n << ">";
-      NS_TEST_EXPECT_MSG_EQ_INTERNAL (item.GetTypeId ().GetName (), oss.str (), "trivial", file, line);
-      NS_TEST_EXPECT_MSG_EQ_INTERNAL (item.GetStart (), e.start, "trivial", file, line);
-      NS_TEST_EXPECT_MSG_EQ_INTERNAL (item.GetEnd (), e.end, "trivial", file, line);
+      NS_TEST_EXPECT_MSG_EQ (item.GetTypeId ().GetName (), oss.str (), "trivial");
+      NS_TEST_EXPECT_MSG_EQ (item.GetStart (), e.start, "trivial");
+      NS_TEST_EXPECT_MSG_EQ (item.GetEnd (), e.end, "trivial");
       ATestTagBase *tag = dynamic_cast<ATestTagBase *> (item.GetTypeId ().GetConstructor () ());
       NS_TEST_EXPECT_MSG_NE (tag, 0, "trivial");
       item.GetTag (*tag);
@@ -503,7 +498,7 @@
 }
 
 void
-PacketTest::DoCheckData (Ptr<const Packet> p, const char *file, int line, uint32_t n, ...)
+PacketTest::DoCheckData (Ptr<const Packet> p, uint32_t n, ...)
 {
   std::vector<struct Expected> expected;
   va_list ap;
@@ -526,9 +521,9 @@
       struct Expected e = expected[j];
       std::ostringstream oss;
       oss << "anon::ATestTag<" << e.n << ">";
-      NS_TEST_EXPECT_MSG_EQ_INTERNAL (item.GetTypeId ().GetName (), oss.str (), "trivial", file, line);
-      NS_TEST_EXPECT_MSG_EQ_INTERNAL (item.GetStart (), e.start, "trivial", file, line);
-      NS_TEST_EXPECT_MSG_EQ_INTERNAL (item.GetEnd (), e.end, "trivial", file, line);
+      NS_TEST_EXPECT_MSG_EQ (item.GetTypeId ().GetName (), oss.str (), "trivial");
+      NS_TEST_EXPECT_MSG_EQ (item.GetStart (), e.start, "trivial");
+      NS_TEST_EXPECT_MSG_EQ (item.GetEnd (), e.end, "trivial");
       ATestTagBase *tag = dynamic_cast<ATestTagBase *> (item.GetTypeId ().GetConstructor () ());
       NS_TEST_EXPECT_MSG_NE (tag, 0, "trivial");
       item.GetTag (*tag);
@@ -601,7 +596,7 @@
 
   CHECK (frag0, 3, E (1, 0, 10), E (2, 0, 10), E (3, 0, 10));
   frag0->AddAtEnd (frag1);
-  CHECK (frag0, 9, 
+  CHECK (frag0, 9,
          E (1, 0, 10), E (2, 0, 10), E (3, 0, 10),
          E (1, 10, 100), E (2, 10, 100), E (4, 10, 100),
          E (1, 100, 1000), E (2, 100, 1000), E (5, 100, 1000));
@@ -724,7 +719,7 @@
     p1->Serialize (buffer, serializedSize);
 
     Ptr<Packet> p2 = Create<Packet> (buffer, serializedSize, true);
-    
+
     delete [] buffer;
 
     ATestTag<10> a2;
@@ -758,9 +753,9 @@
     p1->Serialize (buffer, serializedSize);
 
     Ptr<Packet> p2 = Create<Packet> (buffer, serializedSize, true);
-    
+
     delete [] buffer;
-    
+
     CHECK_DATA (p2, 3, E_DATA (10, 0, 1000, 65), E_DATA (11, 0, 1000, 66), E_DATA (12, 0, 1000, 67));
   }
 
@@ -858,7 +853,7 @@
   {
     Ptr<Packet> tmp = Create<Packet> (0);
     ALargeTestTag a;
-    tmp->AddPacketTag (a); 
+    tmp->AddPacketTag (a);
   }
 }
 
@@ -951,11 +946,8 @@
   ATestTag<5> t5 (1); \
   ATestTag<6> t6 (1); \
   ATestTag<7> t7 (1); \
-  const int tagLast = 7;  /* length of ref PacketTagList */ \
-  NS_UNUSED (tagLast) /* silence warnings */
- 
-  
-  
+  [[maybe_unused]] const int tagLast = 7;  /* length of ref PacketTagList */
+
 void
 PacketTagListTest::CheckRefList (const PacketTagList & ptl,
                                  const char * msg,
@@ -970,7 +962,7 @@
   CheckRef (ptl, t6, msg, miss == 6);
   CheckRef (ptl, t7, msg, miss == 7);
 }
-  
+
 int
 PacketTagListTest::RemoveTime (const PacketTagList & ref,
                                ATestTagBase & t,
@@ -1021,7 +1013,7 @@
   std::cout << GetName () << "begin" << std::endl;
 
   MAKE_TEST_TAGS ;
-  
+
   PacketTagList ref;  // empty list
   ref.Add (t1);       // last
   ref.Add (t2);       // post merge
@@ -1030,7 +1022,7 @@
   ref.Add (t5);       // merge precursor
   ref.Add (t6);       // pre-merge
   ref.Add (t7);       // first
-  
+
   { // Peek
     std::cout << GetName () << "check Peek (missing tag) returns false"
               << std::endl;
@@ -1049,7 +1041,7 @@
       CheckRefList (ptl, "assignment copy");
     }
   }
-  
+
   { // Removal
 #   define RemoveCheck(n)                               \
     { PacketTagList p ## n = ref;			\
@@ -1057,7 +1049,7 @@
       CheckRefList (ref,     "remove " #n " orig");	\
       CheckRefList (p ## n, "remove " #n " copy", n);   \
     }
-    
+
     { // Remove single tags from list
       std::cout << GetName () << "check removal of each tag" << std::endl;
       RemoveCheck (1);
@@ -1068,7 +1060,7 @@
       RemoveCheck (6);
       RemoveCheck (7);
     }
-    
+
     { // Remove in the presence of a merge
       std::cout << GetName () << "check removal doesn't disturb merge "
                 << std::endl;
@@ -1076,7 +1068,7 @@
       ptl.Remove (t7);
       ptl.Remove (t6);
       ptl.Remove (t5);
-      
+
       PacketTagList mrg = ptl;  // merged list
       ATestTag<8> m5 (1);
       mrg.Add (m5);             // ptl and mrg differ
@@ -1099,7 +1091,7 @@
   { // Replace
 
     std::cout << GetName () << "check replacing each tag" << std::endl;
-      
+
 #   define ReplaceCheck(n)					\
     t ## n .m_data = 2;						\
     { PacketTagList p ## n = ref;				\
@@ -1107,7 +1099,7 @@
       CheckRefList (ref,     "replace " #n " orig");		\
       CheckRef     (p ## n, t ## n, "replace " #n " copy");	\
     }
-    
+
     ReplaceCheck (1);
     ReplaceCheck (2);
     ReplaceCheck (3);
@@ -1116,7 +1108,7 @@
     ReplaceCheck (6);
     ReplaceCheck (7);
   }
-  
+
   { // Timing
     std::cout << GetName () << "add+remove timing" << std::endl;
     int flm = std::numeric_limits<int>::max ();
@@ -1128,7 +1120,7 @@
     std::cout << GetName () << "min add+remove time: "
               << std::setw (8) << flm        << " ticks"
               << std::endl;
-    
+
     std::cout << GetName () << "remove timing" << std::endl;
     // tags numbered from 1, so add one for (unused) entry at 0
     std::vector <int> rmn (tagLast + 1, std::numeric_limits<int>::max ());
@@ -1144,7 +1136,7 @@
         case 2:  now = RemoveTime (ref, t2);  break;
         case 1:  now = RemoveTime (ref, t1);  break;
 	}  // switch
-	
+
 	if (now < rmn[j]) rmn[j] = now;
       } // for tag j
     } // for iteration i
@@ -1155,7 +1147,7 @@
                 << std::endl;
     }
   }  // Timing
-    
+
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/bit-deserializer.h ns-3.36/src/network/utils/bit-deserializer.h
--- ns-3.35/src/network/utils/bit-deserializer.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/bit-deserializer.h	2022-04-30 18:23:58.110734700 -0700
@@ -71,6 +71,7 @@
    * The maximum number of bits to be deserialized in one single call is 64.
    *
    * \param size The number of bits to pop.
+   * \return The popped bits value
    */
   uint64_t GetBits (uint8_t size);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/drop-tail-queue.h ns-3.36/src/network/utils/drop-tail-queue.h
--- ns-3.35/src/network/utils/drop-tail-queue.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/drop-tail-queue.h	2022-04-30 18:23:58.110734700 -0700
@@ -71,7 +71,7 @@
 TypeId
 DropTailQueue<Item>::GetTypeId (void)
 {
-  static TypeId tid = TypeId (("ns3::DropTailQueue<" + GetTypeParamName<DropTailQueue<Item> > () + ">").c_str ())
+  static TypeId tid = TypeId ("ns3::DropTailQueue<" + GetTypeParamName<DropTailQueue<Item> > () + ">")
     .SetParent<Queue<Item> > ()
     .SetGroupName ("Network")
     .template AddConstructor<DropTailQueue<Item> > ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/net-device-queue-interface.h ns-3.36/src/network/utils/net-device-queue-interface.h
--- ns-3.35/src/network/utils/net-device-queue-interface.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/net-device-queue-interface.h	2022-04-30 18:23:58.110734700 -0700
@@ -347,12 +347,10 @@
   NotifyQueuedBytes (item->GetSize ());
 
   NS_ASSERT_MSG (m_device, "Aggregated NetDevice not set");
-  Ptr<Packet> p = Create<Packet> (m_device->GetMtu ());
-
   // After enqueuing a packet, we need to check whether the queue is able to
   // store another packet. If not, we stop the queue
 
-  if (queue->GetCurrentSize () + p > queue->GetMaxSize ())
+  if (queue->WouldOverflow (1, m_device->GetMtu ()))
     {
       NS_LOG_DEBUG ("The device queue is being stopped (" << queue->GetCurrentSize ()
                     << " inside)");
@@ -370,13 +368,11 @@
   NotifyTransmittedBytes (item->GetSize ());
 
   NS_ASSERT_MSG (m_device, "Aggregated NetDevice not set");
-  Ptr<Packet> p = Create<Packet> (m_device->GetMtu ());
-
   // After dequeuing a packet, if there is room for another packet we
   // call Wake () that ensures that the queue is not stopped and restarts
   // the queue disc if the queue was stopped
 
-  if (queue->GetCurrentSize () + p <= queue->GetMaxSize ())
+  if (!queue->WouldOverflow (1, m_device->GetMtu ()))
     {
       Wake ();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/packet-socket-address.cc ns-3.36/src/network/utils/packet-socket-address.cc
--- ns-3.35/src/network/utils/packet-socket-address.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/packet-socket-address.cc	2022-04-30 18:23:58.114734600 -0700
@@ -42,21 +42,21 @@
   m_isSingleDevice = false;
   m_device = 0;
 }
-void 
+void
 PacketSocketAddress::SetSingleDevice (uint32_t index)
 {
   NS_LOG_FUNCTION (this << index);
   m_isSingleDevice = true;
   m_device = index;
 }
-void 
+void
 PacketSocketAddress::SetPhysicalAddress (const Address address)
 {
   NS_LOG_FUNCTION (this << address);
   m_address = address;
 }
 
-uint16_t 
+uint16_t
 PacketSocketAddress::GetProtocol (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -74,7 +74,7 @@
   NS_LOG_FUNCTION (this);
   return m_device;
 }
-Address 
+Address
 PacketSocketAddress::GetPhysicalAddress (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -86,7 +86,7 @@
   return ConvertTo ();
 }
 
-Address 
+Address
 PacketSocketAddress::ConvertTo (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -102,7 +102,7 @@
   uint32_t copied = m_address.CopyAllTo (buffer + 7, Address::MAX_SIZE - 7);
   return Address (GetType (), buffer, 7 + copied);
 }
-PacketSocketAddress 
+PacketSocketAddress
 PacketSocketAddress::ConvertFrom (const Address &address)
 {
   NS_LOG_FUNCTION (address);
@@ -118,7 +118,7 @@
   device |= buffer[4];
   device <<= 8;
   device |= buffer[5];
-  bool isSingleDevice = (buffer[6] == 1) ? true : false;
+  bool isSingleDevice = (buffer[6] == 1);
   Address physical;
   physical.CopyAllFrom (buffer + 7, Address::MAX_SIZE - 7);
   PacketSocketAddress ad;
@@ -134,13 +134,13 @@
   ad.SetPhysicalAddress (physical);
   return ad;
 }
-bool 
+bool
 PacketSocketAddress::IsMatchingType (const Address &address)
 {
   NS_LOG_FUNCTION (address);
   return address.IsMatchingType (GetType ());
 }
-uint8_t 
+uint8_t
 PacketSocketAddress::GetType (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/pcap-file.cc ns-3.36/src/network/utils/pcap-file.cc
--- ns-3.35/src/network/utils/pcap-file.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/pcap-file.cc	2022-04-30 18:23:58.114734600 -0700
@@ -14,7 +14,7 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- * 
+ *
  * Author:  Craig Dowell (craigdo@ee.washington.edu)
  */
 
@@ -30,7 +30,7 @@
 #include "ns3/log.h"
 #include "ns3/build-profile.h"
 //
-// This file is used as part of the ns-3 test framework, so please refrain from 
+// This file is used as part of the ns-3 test framework, so please refrain from
 // adding any ns-3 specific constructs such as Packet to this file.
 //
 
@@ -53,7 +53,7 @@
     m_nanosecMode (false)
 {
   NS_LOG_FUNCTION (this);
-  FatalImpl::RegisterStream (&m_file); 
+  FatalImpl::RegisterStream (&m_file);
 }
 
 PcapFile::~PcapFile ()
@@ -64,19 +64,19 @@
 }
 
 
-bool 
+bool
 PcapFile::Fail (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_file.fail ();
 }
-bool 
+bool
 PcapFile::Eof (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_file.eof ();
 }
-void 
+void
 PcapFile::Clear (void)
 {
   NS_LOG_FUNCTION (this);
@@ -168,7 +168,7 @@
   return ((val >> 8) & 0x00ff) | ((val << 8) & 0xff00);
 }
 
-uint32_t 
+uint32_t
 PcapFile::Swap (uint32_t val)
 {
   NS_LOG_FUNCTION (this << val);
@@ -207,7 +207,7 @@
   // at the start of the file.
   //
   m_file.seekp (0, std::ios::beg);
- 
+
   //
   // We have the ability to write out the pcap file header in a foreign endian
   // format, so we need a temp place to swap on the way out.
@@ -274,7 +274,7 @@
   // swapped versions of the standard magic number, and normal and byte swapped
   // versions of the magic number indicating nanosecond resolution timestamps.
   //
-  if (m_fileHeader.m_magicNumber != MAGIC && m_fileHeader.m_magicNumber != SWAPPED_MAGIC && 
+  if (m_fileHeader.m_magicNumber != MAGIC && m_fileHeader.m_magicNumber != SWAPPED_MAGIC &&
       m_fileHeader.m_magicNumber != NS_MAGIC && m_fileHeader.m_magicNumber != NS_SWAPPED_MAGIC)
     {
       m_file.setstate (std::ios::failbit);
@@ -284,8 +284,8 @@
   // If the magic number is swapped, then we can assume that everything else we read
   // is swapped.
   //
-  m_swapMode = (m_fileHeader.m_magicNumber == SWAPPED_MAGIC 
-                || m_fileHeader.m_magicNumber == NS_SWAPPED_MAGIC) ? true : false;
+  m_swapMode = (m_fileHeader.m_magicNumber == SWAPPED_MAGIC
+                || m_fileHeader.m_magicNumber == NS_SWAPPED_MAGIC);
 
   if (m_swapMode)
     {
@@ -296,7 +296,7 @@
   // Timestamps can either be microsecond or nanosecond
   //
   m_nanosecMode = ((m_fileHeader.m_magicNumber == NS_MAGIC) ||
-                   (m_fileHeader.m_magicNumber == NS_SWAPPED_MAGIC)) ? true : false;
+                   (m_fileHeader.m_magicNumber == NS_SWAPPED_MAGIC));
 
   //
   // We only deal with one version of the pcap file format.
@@ -307,7 +307,7 @@
     }
 
   //
-  // A quick test of reasonablness for the time zone offset corresponding to 
+  // A quick test of reasonablness for the time zone offset corresponding to
   // a real place on the planet.
   //
   if (m_fileHeader.m_zone < -12 || m_fileHeader.m_zone > 12)
@@ -439,7 +439,7 @@
   NS_BUILD_DEBUG(m_file.flush());
 }
 
-void 
+void
 PcapFile::Write (uint32_t tsSec, uint32_t tsUsec, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this << tsSec << tsUsec << p);
@@ -448,7 +448,7 @@
   NS_BUILD_DEBUG(m_file.flush());
 }
 
-void 
+void
 PcapFile::Write (uint32_t tsSec, uint32_t tsUsec, const Header &header, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this << tsSec << tsUsec << &header << p);
@@ -467,11 +467,11 @@
 
 void
 PcapFile::Read (
-  uint8_t * const data, 
+  uint8_t * const data,
   uint32_t maxBytes,
-  uint32_t &tsSec, 
-  uint32_t &tsUsec, 
-  uint32_t &inclLen, 
+  uint32_t &tsSec,
+  uint32_t &tsUsec,
+  uint32_t &inclLen,
   uint32_t &origLen,
   uint32_t &readLen)
 {
@@ -505,7 +505,7 @@
   origLen = header.m_origLen;
 
   //
-  // We don't always want to force the client to keep a maximum length buffer 
+  // We don't always want to force the client to keep a maximum length buffer
   // around so we allow her to specify a minimum number of bytes to read.
   // Usually 64 bytes is enough information to print all of the headers, so
   // it isn't typically necessary to read all thousand bytes of an echo packet,
@@ -525,7 +525,7 @@
 }
 
 bool
-PcapFile::Diff (std::string const & f1, std::string const & f2, 
+PcapFile::Diff (std::string const & f1, std::string const & f2,
                 uint32_t & sec, uint32_t & usec, uint32_t & packets,
                 uint32_t snapLen)
 {
@@ -570,7 +570,7 @@
         }
 
       ++packets;
-      
+
       if (tsSec1 != tsSec2 || tsUsec1 != tsUsec2)
         {
           diff = true; // Next packet timestamps do not match
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/queue.cc ns-3.36/src/network/utils/queue.cc
--- ns-3.35/src/network/utils/queue.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/queue.cc	2022-04-30 18:23:58.114734600 -0700
@@ -220,4 +220,17 @@
   return m_maxSize;
 }
 
+bool
+QueueBase::WouldOverflow (uint32_t nPackets, uint32_t nBytes) const
+{
+  if (m_maxSize.GetUnit () == QueueSizeUnit::PACKETS)
+    {
+      return (m_nPackets + nPackets > m_maxSize.GetValue ());
+    }
+  else
+    {
+      return (m_nBytes + nBytes > m_maxSize.GetValue ());
+    }
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/queue.h ns-3.36/src/network/utils/queue.h
--- ns-3.35/src/network/utils/queue.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/queue.h	2022-04-30 18:23:58.114734600 -0700
@@ -27,7 +27,6 @@
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 #include "ns3/traced-value.h"
-#include "ns3/unused.h"
 #include "ns3/log.h"
 #include "ns3/queue-size.h"
 #include "ns3/queue-item.h"
@@ -179,6 +178,15 @@
    */
   QueueSize GetMaxSize (void) const;
 
+  /**
+   * \brief Check if the queue would overflow with additional bytes or packets
+   * Note: the check is performed according to the queue's operating mode (bytes or packets).
+   * \param nPackets number of additional packets
+   * \param nBytes number of additional bytes
+   * \return true if the queue should overflow, false otherwise.
+   */
+  bool WouldOverflow (uint32_t nPackets, uint32_t nBytes) const;
+
 #if 0
   // average calculation requires keeping around
   // a buffer with the date of arrival of past received packets
@@ -457,7 +465,7 @@
 Queue<Item>::GetTypeId (void)
 {
   std::string name = GetTypeParamName<Queue<Item> > ();
-  static TypeId tid = TypeId (("ns3::Queue<" + name + ">").c_str ())
+  static TypeId tid = TypeId ("ns3::Queue<" + name + ">")
     .SetParent<QueueBase> ()
     .SetGroupName ("Network")
     .AddTraceSource ("Enqueue", "Enqueue a packet in the queue.",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/queue-item.cc ns-3.36/src/network/utils/queue-item.cc
--- ns-3.35/src/network/utils/queue-item.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/queue-item.cc	2022-04-30 18:23:58.114734600 -0700
@@ -134,8 +134,8 @@
 {
   os << GetPacket () << " "
      << "Dst addr " << m_address << " "
-     << "proto " << (uint16_t) m_protocol << " "
-     << "txq " << (uint8_t) m_txq
+     << "proto " << m_protocol << " "
+     << "txq " << +m_txq
   ;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/queue-item.h ns-3.36/src/network/utils/queue-item.h
--- ns-3.35/src/network/utils/queue-item.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/queue-item.h	2022-04-30 18:23:58.114734600 -0700
@@ -54,6 +54,11 @@
 
   virtual ~QueueItem ();
 
+  // Delete default constructor, copy constructor and assignment operator to avoid misuse
+  QueueItem () = delete;
+  QueueItem (const QueueItem &) = delete;
+  QueueItem & operator = (const QueueItem &) = delete;
+
   /**
    * \return the packet included in this item.
    */
@@ -102,26 +107,6 @@
 
 private:
   /**
-   * \brief Default constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueItem ();
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueItem (const QueueItem &);
-  /**
-   * \brief Assignment operator
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  QueueItem &operator = (const QueueItem &);
-
-  /**
    * The packet contained in the queue item.
    */
   Ptr<Packet> m_packet;
@@ -157,6 +142,11 @@
 
   virtual ~QueueDiscItem ();
 
+  // Delete default constructor, copy constructor and assignment operator to avoid misuse
+  QueueDiscItem () = delete;
+  QueueDiscItem (const QueueDiscItem &) = delete;
+  QueueDiscItem & operator = (const QueueDiscItem &) = delete;
+
   /**
    * \brief Get the MAC address included in this item
    * \return the MAC address included in this item.
@@ -227,26 +217,6 @@
   virtual uint32_t Hash (uint32_t perturbation = 0) const;
 
 private:
-  /**
-   * \brief Default constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueDiscItem ();
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueDiscItem (const QueueDiscItem &);
-  /**
-   * \brief Assignment operator
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  QueueDiscItem &operator = (const QueueDiscItem &);
-
   Address m_address;      //!< MAC destination address
   uint16_t m_protocol;    //!< L3 Protocol number
   uint8_t m_txq;          //!< Transmission queue index
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/network/utils/queue-size.cc ns-3.36/src/network/utils/queue-size.cc
--- ns-3.35/src/network/utils/queue-size.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/network/utils/queue-size.cc	2022-04-30 18:23:58.114734600 -0700
@@ -20,7 +20,6 @@
 
 #include "queue-size.h"
 #include "ns3/log.h"
-#include "ns3/unused.h"
 
 namespace ns3 {
 
@@ -181,9 +180,8 @@
 QueueSize::QueueSize (std::string size)
 {
   NS_LOG_FUNCTION (this << size);
-  bool ok = DoParse (size, &m_unit, &m_value);
+  [[maybe_unused]] bool ok = DoParse (size, &m_unit, &m_value);
   NS_ABORT_MSG_IF (!ok, "Could not parse queue size: " << size);
-  NS_UNUSED (ok); // suppress compiler warning
 }
 
 /* For printing of queue size */
